import java.net.*;
import java.io.*;

/**
 * @author Ana Sanz Merino [University of California Berkeley, 2003]
 * @version $Revision: 1.1.1.1 $
 */


public class addIP
{
    private static final int addIpPort = 9000;

    static boolean trace = false;
 
    public static void main(String[] args) throws Exception
    {
	parseTraceArg(args);

	DatagramSocket sock = new DatagramSocket(addIpPort);
	DatagramPacket pack;
        byte[] buff;
        String ipAddress;

	while (true) {
            /*Read the information about the entry to add */
	    buff = new byte[500];
	    pack = new DatagramPacket(buff, buff.length);
	    sock.receive(pack);
	    ipAddress = new String(pack.getData(), 0, pack.getLength());

	    if (trace) {
	        System.out.println("Authenticated IP Address: " + ipAddress);
            }

            /*Add the entry */
            Runtime rt = Runtime.getRuntime();
	    String command = null;
            Process ipTables = null;
            int result = -1;

            command = "/sbin/iptables -t nat -L WEB_REDIRECT";
            ipTables = rt.exec(command);
            InputStream old_in = ipTables.getInputStream();
            InputStreamReader old_reader = new InputStreamReader(old_in);
            LineNumberReader old_linereader = new LineNumberReader(old_reader);
            String old_entry = null;
            boolean end_of_stream = false;
            boolean found = false;
            while (!end_of_stream && !found) {
                old_entry = old_linereader.readLine();
                if (old_entry == null) {
                    end_of_stream = true;
                } else {
                    if ((old_entry.indexOf(ipAddress)) != -1) {
                        if (trace) {
                            System.out.println("Entry to add already exists");
                        }
                        found = true;
                    }
                }
            }

            if (!found) {
                command = "/sbin/iptables -A OUT_NETWORK -s " + ipAddress +
                          " -j AUTH_IP";
                ipTables = rt.exec(command);
                result = ipTables.waitFor();
                if (result != 0) {
                    throw new Exception("Add IP to OUT_NETWORK failed");
                }

                command = "/sbin/iptables -A IN_NETWORK -d " + ipAddress +
                          " -j AUTH_IP";
                ipTables = rt.exec(command);
                result = ipTables.waitFor();
                if (result != 0) {
                    throw new Exception("Add IP to IN_NETWORK failed");
                }

                command = "/sbin/iptables -t nat -I WEB_REDIRECT -s " + ipAddress +
                          " -j RETURN";
                ipTables = rt.exec(command);
                result = ipTables.waitFor();
                if (result != 0) {
                    throw new Exception("Add IP to WEB_REDIRECT failed");
                }
            }
        }
    }


    private static void parseTraceArg(String[] args)
    {
        // The trace argument must be the first one.
        // This is to save execution time
        // If -t is present just after the program name, traces will be output

        if (args.length >= 1)
        {
            if (args[0].equals("-t"))
            {
                trace = true;
            }
        }
    }
}
