import java.net.*;

/**
 * @author Ana Sanz Merino [University of California Berkeley, 2003]
 * @version $Revision: 1.1.1.1 $
 */


public class removeIP
{
    private static final int removeIpPort = 9001;

    static boolean trace = false;
 
    public static void main(String[] args) throws Exception
    {
	parseTraceArg(args);

	DatagramSocket sock = new DatagramSocket(removeIpPort);
	DatagramPacket pack;
        byte[] buff;
        String data;

	while (true) {
            /* Receive information about the entry to remove */
	    buff = new byte[500];
	    pack = new DatagramPacket(buff, buff.length);
	    sock.receive(pack);
	    data = new String(pack.getData());

	    if (trace) {
	        System.out.println("IP Address to remove: " + data);
            }


            /* Remove the entry */
            //In case of error, we don't do anything, since the most likely cause
            // is that the entry was already removed. If the entry to remove does
            // not exist, we can consider the result correct.
            String command = null;
            Runtime rt = Runtime.getRuntime();
            Process ipTables = null;
            int result = -1;

            command = "/sbin/iptables -D OUT_NETWORK -s " + ipAddress + 
                      " -j AUTH_IP";
            ipTables = rt.exec(command);
            result = ipTables.waitFor();
            if (result != 0) {
                if (trace) {
                    System.out.println("Entry to remove in OUT_NETWORK does not exist");
                }
            }

            command = "/sbin/iptables -D IN_NETWORK -d " + ipAddress + 
                      " -j AUTH_IP";
            ipTables = rt.exec(command);
            result = ipTables.waitFor();
            if (result != 0) {
                if (trace) {
                    System.out.println("Entry to remove in IN_NETWORK does not exist");
                }
            }

            command = "/sbin/iptables -t nat -D WEB_REDIRECT -s " +  ipAddress +
                      " -j RETURN";
            ipTables = rt.exec(command);
            result = ipTables.waitFor();
            if (result != 0) {
                if (trace) {
                    System.out.println("Entry to remove in WEB_REDIRECT does not exist");
                }
            }
        }
    }


    private static void parseTraceArg(String[] args)
    {
        // The trace argument must be the first one.
        // This is to save execution time
        // If -t is present just after the program name, traces will be output

        if (args.length >= 1)
        {
            if (args[0].equals("-t"))
            {
                trace = true;
            }
        }
    }
}
