/*
 * $Id: LibertyAuthnRequestEnvelope.java,v 1.6.2.1 2002/09/17 01:52:22 jsergent Exp $
 * LibertyAuthnRequestEnvelope.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty;
import java.util.Iterator;
import java.util.List;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Data bindings for the lib:AuthnRequestEnvelope element.  Used by
 * Liberty-enabled clients and proxies.  Not yet used.
 * @author Jonathan Sergent
 * @version $Revision: 1.6.2.1 $
 */
public class LibertyAuthnRequestEnvelope extends XMLElement implements LibertyElement {
    public LibertyAuthnRequest authnRequest = null;
    public String assertionConsumerServiceURL = null;
    public String providerID = null;
    public String providerName = null;
    public LibertyIDPList idpList = null;
    public boolean isPassive = true;

    public Element getElement(Document doc) {
	Element e = doc.createElementNS(LIB_NS_URI, "lib:AuthnRequestEnvelope");
	addAttributesTo(e);
	addChildrenTo(e);
	return e;
    }

    protected void addAttributesTo(Element e) {
    }

    protected void addChildrenTo(Element e) {
	if (authnRequest != null) {
	    e.appendChild(authnRequest.getElement(e.getOwnerDocument()));
	}
	appendNewChildNSWithText(e, LIB_NS_URI,
			  "lib:ProviderID", providerID);
	appendNewChildNSWithText(e, LIB_NS_URI,
			  "lib:ProviderName", providerName);
	appendNewChildNSWithText(e, LIB_NS_URI,
			  "lib:AssertionConsumerServiceURL",
			  assertionConsumerServiceURL);
	if (idpList != null) {
	    e.appendChild(idpList.getElement(e.getOwnerDocument()));
	}
	appendNewChildNSWithText(e, LIB_NS_URI,
			  "lib:IsPassive", String.valueOf(isPassive));	
    }

    public LibertyAuthnRequest getAuthnRequest() {
	return authnRequest;
    }

    public void setAuthnRequest(LibertyAuthnRequest value) {
	authnRequest = value;
    }

    public String getAssertionConsumerServiceURL() {
	return assertionConsumerServiceURL;
    }

    public void setAssertionConsumerServiceURL(String value) {
	assertionConsumerServiceURL = value;
    }

    public LibertyIDPList getIDPList() {
	return idpList;
    }

    public void setIDPList(LibertyIDPList value) {
	idpList = value;
    }
}
