/*
 * $Id: LibertySoapLogoutNotification.java,v 1.4.2.1 2002/09/17 01:52:24 jsergent Exp $
 * LibertySoapLogoutNotification.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty;

import javax.xml.soap.SOAPMessage;
import org.w3c.dom.Element;

/**
 * Subclass of LibertyLogoutNotification that implements the SOAP profile.
 *
 * @author Jonathan Sergent
 * @version $Revision: 1.4.2.1 $
 */
public class LibertySoapLogoutNotification extends LibertyLogoutNotification implements LibertySoapMessage {
    /**
     * Parses the given SOAP message and updates the object to match.
     * Note that previously set values may persist if the given query does not
     * contain values for the fields, so it is usually correct to only call this
     * method on a newly created object.
     *
     * May throw an exception if the request cannot be parsed or it contains
     * invalid data (including a signature that can't be verified).
     *
     * @param	msg	The SOAP message
     */
    public void parse(SOAPMessage msg) throws Exception {
	parse(SoapUtils.getRequestElement(msg));
    }

    /**
     * Inserts the message into the body of the given SOAP message.
     *
     * @param	msg	The SOAP message
     */
    public void addToBody(SOAPMessage msg) throws Exception {
        SoapUtils.addToBody(this, msg);
    }
}
