/*
 * $Id: SAMLSubjectStatement.java,v 1.5.2.1 2002/09/17 01:52:32 jsergent Exp $
 * SAMLSubjectStatement.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty.saml;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Data bindings for saml:SubjectStatement type.  Get and set methods
 * correspond to child elements and attributes in the XML schema for this
 * element.
 * @author Jonathan Sergent 
 * @version $Revision: 1.5.2.1 $ 
 */ 

public abstract class SAMLSubjectStatement extends SAMLStatement {
    private SAMLSubject subject = null;


    public void parse(Element e) {
	NodeList list = e.getChildNodes();
	for (int j = 0; j < list.getLength(); j++) {
	    if (list.item(j) instanceof org.w3c.dom.Text) { continue; }
	    Element child = (Element) list.item(j);
	    if (isElement(child, SAML_NS_URI, "Subject")) {
		SAMLSubject c;
		if (child.getAttributeNS(XSI_NS_URI, "type").equals("lib:SubjectType")) {
		    c = new com.sun.liberty.LibertySubject();
		} else {
		    c = new SAMLSubject();
		}
		c.parse(child);
		setSubject(c);
	    }
	}
    }
    
    protected void addChildrenTo(Element sss) {
        if (subject != null) {
            sss.appendChild(subject.getElement(sss.getOwnerDocument()));
        }
    }


    public SAMLSubject getSubject() {
        return subject;
    }

    public void setSubject(SAMLSubject value) {
        subject = value;
    }
}
