/*
 * $Id: ConfigServlet.java,v 1.3.2.1 2002/09/17 01:52:33 jsergent Exp $
 * ConfigServlet.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty.servlets;
import com.sun.liberty.Config;
import java.util.Properties;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServlet;
import org.apache.xml.security.Init;

/**
 * This servlet is never actually invoked.  It is here merely so that it
 * can obtain configuration information from the deployment descriptor
 * at initialization time and propagate it to the rest of the system.
 */
public class ConfigServlet extends HttpServlet {
    public void init(ServletConfig config)
    throws javax.servlet.ServletException {
	super.init(config);
	final ServletContext context = config.getServletContext();
	Properties ctxProps = new Properties() {
	    public String getProperty(String key) {
		return context.getInitParameter(key);
	    }
	    public java.util.Enumeration propertyNames() {
		return context.getInitParameterNames();
	    }
	};
	Config.init(ctxProps);
	org.apache.xml.security.Init.init();
    }
}
