package ucb.eecs.sahara.sso.anp;

/**
 * Interface specifying constants for use in XMLElement subclasses that
 * implement elements from the ANP core schema.  Includes namespace
 * identifier URIs.
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */
public interface ANPElement {
    /** Base URI for ANP namespaces */
    public static final String NS_URI = "urn:ucb:eecs:sahara:sso:ANP:1.0";
    /** Base URI for ANP schemas */
    public static final String SCHEMA_NS_URI = NS_URI;
    /** URI for ANP core schema */
    public static final String ANP_NS_URI = SCHEMA_NS_URI;
    /** Namespace identifier for ANP core schema */
    public static final String ANP_NS_ID = "anp";
    
    /** Base URI for protocol profiles */
    public static final String PROFILE_NS_URI = NS_URI + ":profiles";
    /** URI for web browser ANP profile */
    public static final String WEB_BRWS_PROFILE_URI
        = PROFILE_NS_URI + ":web-brws";
    /** URI for web client ANP profile */
    public static final String WEB_CLIENT_PROFILE_URI
        = PROFILE_NS_URI + ":web-client";

    /** Base URI for protocol bindings */
    public static final String BINDING_NS_URI = NS_URI + ":bindings";
    /* SAML binding identifiers */
    public static final String SOAP_BINDING
        = BINDING_NS_URI + ":SOAP-binding";
}
