package ucb.eecs.sahara.sso.anp;

import ucb.eecs.sahara.sso.anp.ANPElement;
import ucb.eecs.sahara.sso.anp.saml.SAMLPQuery;
import com.sun.liberty.saml.SAMLElement;
import com.sun.liberty.Config;
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Data bindings for the anp:Request element.  Get and set methods
 * correspond to child elements and attributes in the XML schema for this
 * element.
 *
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public class ANPRequest extends ANPAbstractMessage {

    private SAMLPQuery query = null;

    public void parse(Element e) {
        if (Config.debug) {
            System.out.println("p: e:" + e);
            org.w3c.dom.NamedNodeMap m = e.getAttributes();
            for (int i = 0; i < m.getLength(); i++) {
                System.out.println("p: name:" + m.item(i).getNodeName() + " value:" + m.item(i).getNodeValue());
            }
            System.err.println("All attributes extracted");
        }
	NodeList list = e.getChildNodes();
	for (int i = 0; i < list.getLength(); i++) {
	    if (list.item(i) instanceof org.w3c.dom.Text) { continue; }
	    Element child = (Element) list.item(i);
	    if (isElement(child, ANP_NS_URI, "AuthnCapabilitiesQuery")) {
		SAMLPQuery query = new ANPAuthnCapabilitiesQuery();
		query.parse(child);
		setQuery(query);
	    } else if (isElement(child, ANP_NS_URI, "AuthnQuery")) {
		SAMLPQuery query = new ANPAuthnQuery();
		query.parse(child);
		setQuery(query);
	    } else if (isElement(child, ANP_NS_URI, "AuthnContQuery")) {
		SAMLPQuery query = new ANPAuthnContQuery();
		query.parse(child);
		setQuery(query);
	    } else 
		if (Config.debug) {
		    System.err.println("got unknown child: " + child.getNodeName());
		}
	}

	super.parse(e);
    }

    public Element getElement(Document doc) {
	Element r;
	r = doc.createElementNS(ANP_NS_URI, ANP_NS_ID + ":Request");
	addAttributesTo(r);
	addChildrenTo(r);
	return r;
    }

    protected void addAttributesTo(Element s) {
	super.addAttributesTo(s);
    }

    protected void addChildrenTo(Element s) {
	s.appendChild(query.getElement(s.getOwnerDocument()));
	super.addChildrenTo(s);
    }

    public SAMLPQuery getQuery() {
	return query;
    }

    public void setQuery(SAMLPQuery value) {
	query = value;
    }
}
