package ucb.eecs.sahara.sso.anp;

/**
 * Implements enumeration of ANP request processor action identifiers.
 * 
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */
public class ANPRequestProcessorAction implements Comparable {
    private final String name;
    private static int nextOrdinal = 0;
    private final int ordinal = nextOrdinal++;

    private ANPRequestProcessorAction(String name) { this.name = name; }
    public String toString() { return name; }
    public int compareTo(Object o) {
	return ordinal - ((ANPRequestProcessorAction) o).ordinal;
    }

    /** Request was processed, return normal response to user. */
    public static final ANPRequestProcessorAction RETURN_RESPONSE
	= new ANPRequestProcessorAction("RETURN_RESPONSE");
    /** Request processing failed.  Return failure and do not try again. */
    public static final ANPRequestProcessorAction FAILED
	= new ANPRequestProcessorAction("FAILED");
}
