package ucb.eecs.sahara.sso.anp;

import ucb.eecs.sahara.sso.anp.ANPSoapMessage;
import ucb.eecs.sahara.sso.anp.ANPSoapUtils;
import javax.xml.soap.SOAPMessage;
import org.w3c.dom.Element;

/**
 * Subclass of ANPRequest to support the ANP SOAP binding.
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */
public class ANPSoapRequest extends ANPRequest implements ANPSoapMessage {
    /**
     * Parses the given SOAP message and updates the object to match.
     * Note that previously set values may persist if the given query does not
     * contain values for the fields, so it is usually correct to only call this
     * method on a newly created object.
     *
     * May throw an exception if the request cannot be parsed or it contains
     * invalid data (including a signature that can't be verified).
     *
     * @param	msg	The SOAP message
     */
    public void parse(SOAPMessage msg) throws Exception {
	parse(ANPSoapUtils.getRequestElement(msg));
    }

    /**
     * Inserts the message into the body of the given SOAP message.
     *
     * @param	msg	The SOAP message
     */
    public void addToBody(SOAPMessage msg) throws Exception {
	ANPSoapUtils.addToBody(this, msg);
    }
}
