package ucb.eecs.sahara.sso.anp;

import com.sun.liberty.saml.SAMLAttributeDesignator;
import java.util.List;
import java.util.LinkedList;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Data bindings for anp:UserInfo element.
 *
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public class ANPUserInfo extends SAMLAttributeDesignator implements ANPElement {
    private List attributeValues = null;

    public void parse(Element e) {
        super.parse(e);
        NodeList list = e.getChildNodes();
        for (int i = 0; i < list.getLength(); i++) {
            if (list.item(i) instanceof org.w3c.dom.Text) { continue; }
            Element child = (Element) list.item(i);
            if (isElement(child, SAML_NS_URI, "AttributeValue")) {
                String val = child.getFirstChild().getNodeValue();
                List set = getAttributeValues();
                if (set == null) {
                    set = new LinkedList();
                }
                set.add(val);
                setAttributeValues(set);
            }
        }
    }

    public Element getElement(Document doc) {
        Element a = doc.createElementNS(ANP_NS_URI, ANP_NS_ID + ":UserInfo");
        addAttributesTo(a);
        addChildrenTo(a);
        return a;
    }

    protected void addAttributesTo(Element a) {
        super.addAttributesTo(a);
    }

    protected void addChildrenTo(Element a) {
        iterateAddNewChildrenNSWithText(a, SAML_NS_URI, "saml:AttributeValue",
                                 attributeValues);
    }

    public List getAttributeValues() {
        return attributeValues;
    }

    public void setAttributeValues(List set) {
        attributeValues = set;
    }

}
