package ucb.eecs.sahara.sso.authn;

import com.sun.liberty.Config;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;


/**
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public class SimpleLocalAuthenticator {

    private static final String LOGIN_CONFIGURATION_ID = Config.loginConfID;

    public static AuthenticatorResult authenticate(final String userName,
                                                   final String userPassword)
		  throws Exception
    {
        if (!Config.debugAuthn) {
            if (Config.debug) { System.err.println("doing real authn"); }
            class MyCallbackHandler implements CallbackHandler {
                public void handle(Callback[] callbacks)
                    throws UnsupportedCallbackException {
                        for (int i = 0; i < callbacks.length; i++) {
                            // XXX: Should we support more callbacks here?  Maybe.
                            Callback c = callbacks[i];
                            if (c instanceof NameCallback) {
                                NameCallback nc = (NameCallback) c;
                                nc.setName(userName);
                            } else if (c instanceof PasswordCallback) {
                                PasswordCallback pc = (PasswordCallback) c;
                                pc.setPassword(userPassword.toCharArray());
                            } else {
                                throw new UnsupportedCallbackException
                                    (c, "unrecognized callback");
                            }
                        }
                    }
            }
            CallbackHandler myCallback = new MyCallbackHandler();
            try {
                LoginContext lctx = new LoginContext(LOGIN_CONFIGURATION_ID,
                        myCallback);
                lctx.login();
                if (Config.debug) { System.err.println("real authn succeeds"); }
                return AuthenticatorResult.AUTHN_SUCCESS;
            } catch (LoginException e) {
                if (Config.debug) { System.err.println("real authn failed"); }
                return AuthenticatorResult.AUTHN_FAILED;
            }
        } else {
            if (Config.debug) { System.err.println("doing fake authn"); }
            /* Hack! Log in any user where username == pass. */
            if (userName.equals(userPassword)) {
                if (Config.debug) { System.err.println("fake authn succeeds"); }
                return AuthenticatorResult.AUTHN_SUCCESS;
            }
	    else {
		return AuthenticatorResult.AUTHN_FAILED;
	    }
        }
    }
}
