package ucb.eecs.sahara.sso.authn;

import ucb.eecs.sahara.sso.DebugUtils;
import com.sun.liberty.Config;

import net.sourceforge.jradiusclient.RadiusClient;


/**
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public class SimpleRadiusAuthenticator {

    public static AuthenticatorResult authenticate(final String userName,
                                                   final String userPassword)
		  throws Exception
    {
        RadiusClient radClient = new RadiusClient (Config.radiusServer,
                                 Integer.parseInt(Config.radiusPort),
                                 Integer.parseInt(Config.radiusAcctPort),
                                 Config.radiusSecret, userName);
        DebugUtils.debugTime("SimpleRadiusAuthenticator", "Proceeding to invoke RADIUS client",
                             DebugUtils.LOW_LEVEL_FUNC);
        int res = radClient.authenticate(userPassword);
        DebugUtils.debugTime("SimpleRadiusAuthenticator", "RADIUS client returned",
                             DebugUtils.LOW_LEVEL_FUNC);
        if (res == RadiusClient.ACCESS_ACCEPT) {
            return AuthenticatorResult.AUTHN_SUCCESS;
        }
        else {
	    return AuthenticatorResult.AUTHN_FAILED;
        }
    }
}
